#ifndef INPUTADC0_H
#define INPUTADC0_H

#define DATA_ADC0 8

float32 inputAdc0[DATA_ADC0];
int8 inputAdc0Elements;
int8 inputAdc0WritePointer;
int8 inputAdc0ReadPointer;

void inputAdc0Init ();
void putInputAdc0 (float32 data);
float32 getFromInputAdc0 ();
int1 inputAdc0Empty ();
int1 inputAdc0Full ();

void inputAdc0Init ()
{
   inputAdc0Elements = 0;
   inputAdc0WritePointer = 0;
   inputAdc0ReadPointer = 0;
}

int1 inputAdc0Full ()
{
   if (inputAdc0Elements == DATA_ADC0)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

int1 inputAdc0Empty ()
{
   if (inputAdc0Elements == 0)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

// puts a new Data into the input Raw
void putInputAdc0 (float32 data)
{
   if ( !inputAdc0Full () )
   {
      inputAdc0[inputAdc0WritePointer] = data;
      inputAdc0WritePointer++;
      if ( inputAdc0WritePointer == DATA_ADC0 )
      {
         inputAdc0WritePointer = 0;
      }
      inputAdc0Elements ++;
   }
}

float32 getFromInputAdc0()
{
   float32 dataRead;
   
   if ( !inputAdc0Empty () )
   {
      dataRead = inputAdc0[inputAdc0ReadPointer];
      inputAdc0ReadPointer++;
      if ( inputAdc0ReadPointer == DATA_ADC0 )
      {
         inputAdc0ReadPointer = 0;
      }
      inputAdc0Elements --;
      return (dataRead);
   }
   else
   {
      return (0xFF);
   }
}

#endif
