#ifndef INPUTADC1_H
#define INPUTADC1_H

#define DATA_ADC1 8

float32 inputAdc1[DATA_ADC1];
int8 inputAdc1Elements;
int8 inputAdc1WritePointer;
int8 inputAdc1ReadPointer;

void inputAdc1Init ();
void putInputAdc1 (float32 data);
float32 getFromInputAdc1 ();
int1 inputAdc1Empty ();
int1 inputAdc1Full ();

void inputAdc1Init()
{
   inputAdc1Elements = 0;
   inputAdc1WritePointer = 0;
   inputAdc1ReadPointer = 0;
}

int1 inputAdc1Full()
{
   if (inputAdc1Elements == DATA_ADC1)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

int1 inputAdc1Empty()
{
   if (inputAdc1Elements == 0)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

// puts a new Data into the input Raw
void putInputAdc1 (float32 data)
{
   if (!inputAdc1Full())
   {
      inputAdc1[inputAdc1WritePointer] = data;
      inputAdc1WritePointer++;
      if ( inputAdc1WritePointer == DATA_ADC1 )
      {
         inputAdc1WritePointer = 0;
      }
      inputAdc1Elements ++;
   }
}

float32 getFromInputAdc1()
{
   float32 dataRead;
   
   if (!inputAdc1Empty())
   {
      dataRead = inputAdc1[inputAdc1ReadPointer];
      inputAdc1ReadPointer++;
      if ( inputAdc1ReadPointer == DATA_ADC1 )
      {
         inputAdc1ReadPointer = 0;
      }
      inputAdc1Elements --;
      return (dataRead);
   }
   else
   {
      return (0xFF);
   }
}

#endif
