#ifndef INPUTRAW_H
#define INPUTRAW_H

#define DATA_ELEMENTS 16

int8 inputRaw[DATA_ELEMENTS];
int8 inputRawElements;
int8 inputRawWritePointer;
int8 inputRawReadPointer;

void inputRawInit ();
void putInputRaw (int8 data);
int8 getFromInputRaw ();
int1 inputRawEmpty ();
int1 inputRawFull ();

void inputRawInit ()
{
   inputRawElements = 0;
   inputRawWritePointer = 0;
   inputRawReadPointer = 0;
}

int1 inputRawFull ()
{
   if (inputRawElements == DATA_ELEMENTS)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

int1 inputRawEmpty ()
{
   if (inputRawElements == 0)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

// puts a new Data into the input Raw
void putInputRaw (int8 data)
{
   if ( !inputRawFull () )
   {
      inputRaw[inputRawWritePointer] = data;
      inputRawWritePointer++;
      if ( inputRawWritePointer == DATA_ELEMENTS )
      {
         inputRawWritePointer = 0;
      }
      inputRawElements ++;
   }
}

int8 getFromInputRaw ()
{
   int8 dataRead;
   
   if ( !inputRawEmpty () )
   {
      dataRead = inputRaw[inputRawReadPointer];
      inputRawReadPointer++;
      if ( inputRawReadPointer == DATA_ELEMENTS )
      {
         inputRawReadPointer = 0;
      }
      inputRawElements --;
      return (dataRead);
   }
   else
   {
      return (0xFF);
   }
}

#endif
