#include <string.h>

#ifndef OUTPUTRAW_H
#define OUTPUTRAW_H

#define DATAO_ELEMENTS 32

#if DATAO_ELEMENTS > 255 
   int16 outputRawElements;
   int16 outputRawWritePointer;
   int16 outputRawReadPointer; 
#else
   int8 outputRawElements;
   int8 outputRawWritePointer;
   int8 outputRawReadPointer;
#endif

int8 outputRaw[DATAO_ELEMENTS];

void outputRawInit ();
void putOutputRaw (int8 data);
int8 getFromOutputRaw ();
int1 outputRawEmpty ();
int1 outputRawFull ();

void outputRawInit ()
{
   outputRawElements = 0;
   outputRawWritePointer = 0;
   outputRawReadPointer = 0;
}

int1 outputRawFull ()
{
   if (outputRawElements == DATAO_ELEMENTS)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

int1 outputRawEmpty ()
{
   if (outputRawElements == 0)
   {
      return 1;
   }
   else
   {
      return (0);
   }
}

// puts a new Data into the input Raw
void putOutputRaw (int8 data)
{
   if ( !outputRawFull () )
   {
      outputRaw[outputRawWritePointer] = data;
      outputRawWritePointer++;
      if ( outputRawWritePointer == DATAO_ELEMENTS )
      {
         outputRawWritePointer = 0;
      }
      outputRawElements ++;
   }
}

int8 getFromOutputRaw ()
{
   int8 dataRead;
   
   if ( !outputRawEmpty () )
   {
      dataRead = outputRaw[outputRawReadPointer];
      outputRawReadPointer++;
      if ( outputRawReadPointer == DATAO_ELEMENTS )
      {
         outputRawReadPointer = 0;
      }
      outputRawElements --;
      return (dataRead);
   }
   else
   {
      return (0xFF);
   }
}

void putOnOutputRaw(int8 *str)
{
   int16 i;
   
   for(i = 0; i<strlen(str); i++)
   {
      putOutputRaw(str[i]);
   }
}

void putOnOutputRawL(int8 *str, int16 len)
{
   int16 i;
   
   for(i = 0; i<len; i++)
   {
      putOutputRaw(str[i]);
   }
}

#endif
